//************************************************************************************
//**  
//**  File name:     E:\PIC\AVR\KAZ\COMPARE\M16\16_int.c
//**  Generated by:  Flowcode v4.3.9.65
//**  Date:          Sunday, September 02, 2012 17:34:39
//**  Licence:       Free version
//**  
//**        ***For users exUSSR ***
//**  
//**  
//**     NOT FOR COMMERCIAL USE
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_AVR

//Defines for microcontroller
#define MX_AVR
#define MX_EE
#define MX_EE_SIZE 512
#define MX_SPI
#define MX_SPI_B
#define MX_SPI_SDI 6
#define MX_SPI_SDO 5
#define MX_SPI_SCK 7
#define MX_UART
#define MX_UART_D
#define MX_UART_TX 1
#define MX_UART_RX 0
#define MX_MI2C
#define MX_I2C_C
#define MX_I2C_SDA 1
#define MX_I2C_SCL 0
#define MX_PWM
#define MX_PWM_PORT PORTD
#define MX_PWM_CNT 2
#define MX_PWM_TRIS1 DDRD
#define MX_PWM_1 5
#define MX_PWM_TRIS2 DDRD
#define MX_PWM_2 4
#define MX_PWMTYPE 1

//Functions
#define F_CPU 8000000UL
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\eeprom.h>
#include <avr\wdt.h>
#include <MX_util\delay.h>
#include <MX_util\bit_cmds.h>

//Configuration data
#pragma DATA 0x0, 0xdf
#pragma DATA 0x1, 0xff

//Internal functions
#include "C:\Program Files\Matrix Multimedia\Flowcode AVR V4\FCD\internals.h"

//Macro function declarations
void FCM_COMP();
void FCM_INT();


//Variable declarations
volatile short FCV_ADC;


//Defines:

/**** Macro Substitutions ****
1 = Which ADC Channel
40 = Acquisition time
3 = Conversion Speed
0 = VRef+ Option
500 = VRef Voltage x 0.01V
******************************/




//ADC(0): //Macro function declarations

static void FCD_ADC0_SampleADC();
static char FCD_ADC0_ReadAsByte();
static short FCD_ADC0_ReadAsInt();
static float FCD_ADC0_ReadAsVoltage();
static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE);



//ADC(0): //Macro implementations


static void FCD_ADC0_SampleADC()
{
	
		#define MX_ADC_CHANNEL		1
		#define MX_ADC_SAMP_TIME 	40
		#define MX_ADC_CONV_SP		3
		#define MX_ADC_VREF_OPT		(1 - 0)

		char dda;
		volatile char cnt;

		dda = DDRA;

		//turn selected ADC on
		DDRA &= ~(1 << MX_ADC_CHANNEL);
		ADCSRA = (1 << ADEN) | MX_ADC_CONV_SP;
		ADMUX = (MX_ADC_VREF_OPT << REFS0) | (1 << ADLAR) | MX_ADC_CHANNEL;

		//wait the acquisition time
		cnt = 0;
		while (cnt < MX_ADC_SAMP_TIME) cnt++;

		//begin conversion and wait until it has finished
		ADCSRA |= (1 << ADSC);
		while(ADCSRA & (1 << ADSC));

		DDRA = dda;

		#undef MX_ADC_CHANNEL
		#undef MX_ADC_SAMP_TIME
		#undef MX_ADC_CONV_SP
		#undef MX_ADC_VREF_OPT

}

static char FCD_ADC0_ReadAsByte()
{
	
		FCD_ADC0_SampleADC();

		return ADCH;

}

static short FCD_ADC0_ReadAsInt()
{
	
		int iRetVal;

		FCD_ADC0_SampleADC();

		iRetVal = (ADCL >> 6);
		iRetVal |= (ADCH << 2);
		return (iRetVal);

}

static float FCD_ADC0_ReadAsVoltage()
{
	

		int iSample;
		float fSample, fVoltage, fVperDiv;

		#define MX_ADC_VREF_V		500

		iSample = FCD_ADC0_ReadAsInt();											//Read as 10-bit Integer

		fVoltage = iSample * (float)MX_ADC_VREF_V / 102300.0;			//Find voltage by multiplying sample by resolution

		#undef MX_ADC_VREF_V
		return (fVoltage);

}

static void FCD_ADC0_ReadAsString(char* FCR_RETVAL, char FCR_RETVAL_SIZE)
{
	
		float fVoltage;

		fVoltage = FCD_ADC0_ReadAsVoltage();
		FCI_FLOAT_TO_STRING(fVoltage, 2, FCR_RETVAL, FCR_RETVAL_SIZE);	//Convert to String

}

//Macro implementations

void FCM_COMP()
{
	
	//Output
	//Output: 1 -> A7
	DDRA = DDRA | 0x80;
	if (1)
		PORTA = (PORTA & 0x7f) | 0x80;
	else
		PORTA = PORTA & 0x7f;


	//C Code
	//C Code:
	TCCR1B &= 0xf8;
	TCNT1=0;



	//Delay
	//Delay: 20 us
	delay_us(20);


	//Output
	//Output: 0 -> A7
	DDRA = DDRA | 0x80;
	if (0)
		PORTA = (PORTA & 0x7f) | 0x80;
	else
		PORTA = PORTA & 0x7f;


}

void FCM_INT()
{
	
	//Output
	//Output: 1 -> A0
	DDRA = DDRA | 0x01;
	if (1)
		PORTA = (PORTA & 0xfe) | 0x01;
	else
		PORTA = PORTA & 0xfe;


	//C Code
	//C Code:
	//Interrupt: Enable TCNT1_A
		TCCR1B |= 0x03;


	//Output
	//Output: 0 -> A0
	DDRA = DDRA | 0x01;
	if (0)
		PORTA = (PORTA & 0xfe) | 0x01;
	else
		PORTA = PORTA & 0xfe;


}

int main()
{
	
	//Initialisation
	MCUCSR=0x00;
	wdt_disable();


	//Interrupt initialisation code
	
	//Interrupt
	//Interrupt: Enable INT0
	MCUCR |= (1 << ISC01) | (1 << ISC00);
	sei();
	GICR |= (1 << INT0);


	//Interrupt
	//Interrupt: Enable comp_A
	sei();
	//Interrupt: Enable TCNT1_A
		TCCR1B &= 0xf8;
		TCCR1A &= 0x3F;
		OCR1A=2450-1;
		sei();
		TIMSK |= (1 << OCIE1A);
		TCCR1B &= 0xF7;
		TCCR1B |= (1<<WGM12);



	//Loop
	//Loop: While 1
	while (1)
	{
		//Call Component Macro
		//Call Component Macro: ADC=ADC(0)::ReadAsInt
		FCV_ADC = FCD_ADC0_ReadAsInt();


		//Decision
		//Decision: ADC>594?
		if (FCV_ADC>594)
		{
			//Calculation
			//Calculation:
			//  ADC = 594
			FCV_ADC = 594;
			

		}


		//C Code
		//C Code:
		OCR1A=2450 - (FCV_ADC<<2);



	}


	mainendloop: goto mainendloop;
}

	//Handler code for [INT0]
	#ifndef MX_INT0_HANDLER
	#define MX_INT0_HANDLER
	ISR(INT0_vect)
	{
		FCM_INT();
	}
	#else
	#warning The <INT0 Input> interrupt has previously been enabled, so the macro <INT> may never get called.
	#endif


	//Handler code for [comp_A]
	ISR(TIMER1_COMPA_vect)
		{
			FCM_COMP();
		}



